'Compilable Example:
#Compiler PBWin 10
#Compile Exe  "gbimageviewer.exe"
#Dim All
%Unicode=1
%UseWebBrowser = 1
#Include Once "CWindow.inc"

#Resource Manifest, 1, "files\xptheme.xml"
#Resource Icon logo "images\gbimageviewer.ico"
#Resource Icon xhelp "images\help.ico"
#Resource Icon xcopy "images\copy.ico"
#Resource Icon xprevious "images\previous.ico"
#Resource Icon xnext "images\next.ico"
#Resource Icon xclose "images\closetreex.ico"
#Resource Icon xbookmark "images\bookmark.ico"
#Resource Icon xopen "images\open.ico"
#Resource Icon xopenb "images\openb.ico"
#Resource Icon xsettings "images\settings.ico"

$Ver = "1.0"

Enum Equates Singular
   IDC_TreeView = 500
   IDC_Toolbar
   IDC_ListBox
   IDC_WebBrowser
   IDC_StatusBar

   IDT_Close
   IDT_Web
   IDT_Previous
   IDT_Next
   IDT_Bookmarks
   IDT_OpenFolder
   IDT_OpenFile
   IDT_Settings
   IDT_Help

   IDM_BookMark1
   IDM_BookMark2
   IDM_BookMark3
   IDM_BookMark4
   IDM_BookMark5
   IDM_ClearBookmarks
   IDM_WrapText

End Enum

Global hDlg,hBrowser,hToolbar,hPopupBookmarks,ghHook As Dword
Global ImagesList, CurrentFolder As WStringZ * %Max_Path
Global BookMark1, BookMark2, BookMark3, BookMark4, BookMark5 As WStringZ * %Max_Path

Function PBMain() As Long
   Local bstrURL As WString, pWindow As IWindow, hItem As Dword
   Dialog New Pixels, 0, "gbImageViewer   " + $ver,300,300,600,300, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"

   CreateToolbar
   Control Add Treeview, hDlg, %IDC_TreeView, "TopLeft",  10, 60, 220, 140, %WS_TabStop Or %TVS_HasButtons Or %TVS_LinesAtRoot Or %TVS_HasLines Or %TVS_ShowSelAlways, %WS_Ex_ClientEdge
   Control Add ListBox, hDlg, %IDC_ListBox, ,  10, 150, 170, 140, %LBS_Notify Or %WS_TabStop Or %WS_VScroll Or %LBS_NoIntegralHeight, %WS_Ex_ClientEdge
   Treeview Insert Item hDlg, %IDC_TreeView, 0, %TVI_Last, 1,1,"c:\" To hItem
   Treeview Insert Item hDlg, %IDC_TreeView, hItem, %TVI_Last, 1,4,"n/a" To hItem

   pWindow = Class "CWindow"
   bstrURL = "about:blank"
   hBrowser = pWindow.AddWebBrowserControl(hDlg, %IDC_WebBrowser, bstrURL, Nothing, 235, 60, 400,280)

   Control Add Statusbar, hDlg, %IDC_StatusBar, "",0,0,0,0
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local w,h,iResult As Long, temp$, hNode As Dword
   Local nmtb As TBNotify Ptr, rc As Rect, P As ToolTipText Ptr
   Local N As NM_TreeView Ptr
   Select Case Cb.Msg
      Case %WM_InitDialog
         BuildAcceleratorTable
         settings_ini "get"
         CreateContextMenus
         GoToFolder CurrentFolder
         DisplayFilesInListBox
         If IsFile(CurrentFolder) Then
             GoToFolder CurrentFolder
         Else
             ListBox Select hDlg, %IDC_ListBox, 1
             ListBox Get Text hDlg, %IDC_ListBox, 1 To temp$
             Treeview Get Select hDlg, %IDC_Treeview To hNode
             temp$ = FullTreePath(hNode) + "\" + temp$
             DisplayFileInBrowser temp$
         End If
         Control Set Focus hDlg, %IDC_TreeView

      Case %WM_Size
         Dialog Get Client hDlg To w,h
         Control Set Size hDlg, %IDC_TreeView, 220,(h-85)/2-5
         Control Set Loc  hDlg, %IDC_ListBox, 10,(h-85)/2+60
         Control Set Size hDlg, %IDC_ListBox,  220,(h-85)/2-5
         Control Set Size hDlg, %IDC_WebBrowser, w - 245, h-90

      Case %WM_Destroy
         Treeview Get Select hDlg, %IDC_TreeView To hNode
         ListBox Get Text hDlg, %IDC_ListBox To temp$
         CurrentFolder = FullTreePath(hNode) + "\" + temp$
         settings_ini "save"

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_Close
               Treeview Get Root hDlg, %IDC_TreeView To hNode
               Treeview Select hDlg, %IDC_TreeView, hNode
               Treeview Get Child hDlg, %IDC_TreeView, hNode To hNode
               Do While hNode
                  Treeview Set Expanded hDlg, %IDC_TreeView, hNode, %False
                  Treeview Get Next hDlg, %IDC_TreeView, hNode To hNode
               Loop

            Case %IDM_ClearBookmarks
                Reset BookMark1, BookMark2, BookMark3, BookMark4, BookMark5
                CreateContextMenus
                Beep

            Case %IDT_Bookmarks  : AddBookmark
            Case %IDM_BookMark1 To %IDM_BookMark5
               Menu Get Text hPopupBookMarks, ByCmd Cb.Ctl To temp$
               GoToFolder ((temp$))

            Case %IDT_Next       : SelectNextFile +1
            Case %IDT_Previous   : SelectNextFile -1

            Case %IDT_OpenFolder
                 Treeview Get Select hDlg, %IDC_Treeview To hNode
                 temp$ = FullTreePath(hNode)
                 iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDT_OpenFile
                 ListBox Select hDlg, %IDC_ListBox, 1
                 ListBox Get Text hDlg, %IDC_ListBox, 1 To temp$
                 Treeview Get Select hDlg, %IDC_Treeview To hNode
                 temp$ = FullTreePath(hNode) + "\" + temp$
                 iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDT_Settings
                 Dialog Get Loc hDlg To w,h
                 ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
                 temp$ = InputBox$("", "Image Extensions", ImagesList, w+40,h+150)
                 If Len(temp$) Then ImagesList = LCase$(temp$)

            Case %IDT_Help
                 temp$ = "http://www.garybeene.com/sw/gbimageviewer.htm"
                 iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDC_ListBox
               Select Case Cb.CtlMsg
                  Case %LBN_SelChange
                    ListBox Get Select hDlg, %IDC_ListBox To iResult
                    ListBox Get Text hDlg, %IDC_ListBox, iResult To temp$
                    Treeview Get Select hDlg, %IDC_Treeview To hNode
                    temp$ = FullTreePath(hNode) + "\" + temp$
                    DisplayFileInBrowser temp$
               End Select

         End Select
      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                    Case %IDT_Bookmarks
                       If Len(Bookmark1) Then
                           Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           Call TrackPopupMenu (hPopUpBookmarks, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                       Else
                           Beep
                       End If
                 End Select
           End Select

         Select Case Cb.NmId
            Case %IDT_Close To %IDT_Help
                Select Case Cb.NmCode
                   Case %TTN_GetDispInfo
                      P = Cb.LParam
                      @P.@lpszText = SetToolTips(Cb.NmId)
                End Select

            Case %IDC_TreeView
               Select Case Cb.NmCode
                  Case %TVN_ItemExpanding
                     N = Cb.LParam
                     CreateChildren @N.ItemNew.hItem
                  Case %TVN_SelChanged
                     N = Cb.LParam
                     DisplayFilesInListBox
                     ListBox Select hDlg, %IDC_ListBox, 1
                     ListBox Get Text hDlg, %IDC_ListBox, 1 To temp$
                     Treeview Get Select hDlg, %IDC_Treeview To hNode
                     temp$ = FullTreePath(hNode) + "\" + temp$
                     DisplayFileInBrowser temp$
               End Select
         End Select
   End Select
End Function

Sub CreateChildren (hParent As Dword)
   Local hChild, hTemp As Dword
   Local ChildDIR, ParentDIR, temp As String
   Local FullPath As String

   'get text of parent node that is is expanding
   Treeview Get Text hDlg, %IDC_TreeView, hParent To ParentDIR
   ParentDIR = Trim$(ParentDIR, "\")           'this turns c:\ into c:

   'remove all children to ensure currency of display and directory structure
   Do
      Treeview Get Child hDlg, %IDC_TreeView, hParent To hChild
      If hChild Then Treeview Delete hDlg, %IDC_TreeView, hChild
   Loop While hChild

   'add nodes for each subfolder
   ChildDir = Dir$(FullTreePath(hParent) + "\*.*", Only %SubDir)
   While Len(ChildDIR)
      Treeview Insert Item hDlg, %IDC_TreeView, hParent, %TVI_Last, 0, 0, ChildDIR To hTemp
      ChildDIR = Dir$
   Wend

   'add dummy child to each tree element whose folder has subfolders (causes TreeView to display + sign)
   Treeview Get Child hDlg, %IDC_TreeView, hParent To hChild
   While hChild
      FullPath = FullTreePath(hChild)
      temp = Dir$(FullPath + "\*.*", Only %SubDir)
      If Len(temp) Then Treeview Insert Item hDlg, %IDC_TreeView, hChild, %TVI_Last, 0, 0, "n/a" To hTemp
      Treeview Get Next hDlg, %IDC_TreeView, hChild To hChild
   Wend
End Sub

Function FullTreePath(ByVal hNode As Dword) As String
   'get full directory path for hNode - there is NO \ at end
   'c:
   'c:\data
   Local FullPath, temp As String
   Do
      Treeview Get Text hDlg, %IDC_TreeView, hNode To temp
      FullPath = "\" + temp + FullPath
      Treeview Get Parent hDlg, %IDC_TreeView, hNode To hNode
   Loop Until hNode = 0
   temp$ = Trim$(FullPath,"\")
   Replace "\\" With "\" In temp$
   Function = temp$
End Function

Sub DisplayFilesInListBox  'from selected Tree node
   Local temp As String, hNode As Dword, iCount As Long
   ListBox Reset hDlg, %IDC_ListBox
   Treeview Get Select hDlg, %IDC_Treeview To hNode
   temp = Dir$(FullTreePath(hNode)+"\*.*")
   If Len(temp) Then ListBox Reset hDlg, %IDC_ListBox
   Do
      If ValidExtension(LCase$(PathName$(Extn,temp))) Then Incr iCount : ListBox Add hDlg, %IDC_ListBox, temp
      temp = Dir$
   Loop While Len(temp)
   Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "File Count: " + Str$(iCount)
End Sub

Sub Settings_INI(Task$)
   Local x, y As Long, xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "720", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "500", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "CurrentFolder", "c:\", CurrentFolder, %Max_Path, INIFileName
      Getprivateprofilestring "All", "ImagesList", ".gif.jpg.bmp.png.ico", ImagesList, %Max_Path, INIFileName
      Getprivateprofilestring "All", "BookMark1", Exe.Path$, BookMark1, %Max_Path, INIFileName
      Getprivateprofilestring "All", "BookMark2", "", BookMark2, %Max_Path, INIFileName
      Getprivateprofilestring "All", "BookMark3", "", BookMark3, %Max_Path, INIFileName
      Getprivateprofilestring "All", "BookMark4", "", BookMark4, %Max_Path, INIFileName
      Getprivateprofilestring "All", "BookMark5", "", BookMark5, %Max_Path, INIFileName

      'get value for numeric variables
'      Getprivateprofilestring "All", "Hex", "0", temp, %Max_Path, INIFileName:  HexOut = Val(temp)

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "CurrentFolder",CurrentFolder, INIFileName
      WritePrivateProfileString "All", "ImagesList",ImagesList, INIFileName
      WritePrivateProfileString "All", "BookMark1",BookMark1, INIFileName
      WritePrivateProfileString "All", "BookMark2",BookMark2, INIFileName
      WritePrivateProfileString "All", "BookMark3",BookMark3, INIFileName
      WritePrivateProfileString "All", "BookMark4",BookMark4, INIFileName
      WritePrivateProfileString "All", "BookMark5",BookMark5, INIFileName

      'save numeric variables
'      WritePrivateProfileString "All", "Hex", (Str$(HexOut)), INIFileName

   End If
End Sub

Sub CreateToolbar
    Local hImageList As Dword
    ImageList New Icon 24,24,24,10 To hImageList
    ImageList Add Icon hImageList, "xhelp"     '1
    ImageList Add Icon hImageList, "xprevious" '2
    ImageList Add Icon hImageList, "xnext"     '3
    ImageList Add Icon hImageList, "xclose"    '4
    ImageList Add Icon hImageList, "xbookmark" '5
    ImageList Add Icon hImageList, "xopen"     '6
    ImageList Add Icon hImageList, "xopenb"    '7
    ImageList Add Icon hImageList, "xsettings" '8

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0     'default imagelist
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_Close,  %TbStyle_Button, "Close"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_OpenFolder,  %TbStyle_Button, "Folder"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_OpenFile,  %TbStyle_Button, "File"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Previous,  %TbStyle_Button, "Prev"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_Next,  %TbStyle_Button, "Next"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Bookmarks,  %TbStyle_Button Or %TbStyle_DropDown, "Bookmark"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_Settings,  %TbStyle_Button, "Settings"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Help,  %TbStyle_Button, "Help"

End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_Close        : Function = "Collapse All Nodes"
      Case %IDT_Next         : Function = "Go To Next File in List"
      Case %IDT_Previous     : Function = "Go To Previous File In List"
      Case %IDT_Settings     : Function = "Edit Supported Image Types"
      Case %IDT_Help         : Function = "Display File in Hexadecimal"
      Case %IDT_Bookmarks    : Function = "Bookmark Selected Folder"
      Case %IDT_OpenFolder   : Function = "Open Selected Folder"
      Case %IDT_OpenFile     : Function = "Open Selected File in Default Application"
   End Select
End Function

Sub GoToFolder(TargetFolder As WStringZ * %Max_Path)
   Local hNode, hMatch As Dword, iCount,iDepth,i As Long, temp$, sTerm$
   TargetFolder = LCase$(TargetFolder)
   iDepth = 1
   Treeview Get Root hDlg, %IDC_TreeView To hNode
   Do While hNode
      Treeview Set Expanded hDlg, %IDC_TreeView, hNode, %True
      CreateChildren hNode
      Treeview Get Child hDlg, %IDC_TreeView, hNode To hNode
      Incr iDepth
      sTerm$ = Parse$(TargetFolder, "\", iDepth)
      Do While hNode
         Treeview Get Text hDlg, %IDC_TreeView, hNode To temp$
         If LCase$(temp$) = sTerm$ Then hMatch = hNode : Exit Do
         Treeview Get Next hDlg, %IDC_TreeView, hNode To hNode
      Loop
   Loop
   If hMatch Then
       'select TreeView item
       Treeview Select hDlg, %IDC_TreeView, hMatch
       'select file
       sTerm$ = PathName$(Namex, TargetFolder)
       ListBox Get Count hDlg, %IDC_ListBox To iCount
       For i = 1 To iCount
           ListBox Get Text hDlg, %IDC_ListBox, i To temp$
           If temp$ = sTerm$ Then
               ListBox Select hDlg, %IDC_ListBox, i
               DisplayFileInBrowser ((TargetFolder))
               Exit For
           End If
       Next i
   End If
End Sub

Sub CreateContextMenus
    Menu New PopUp To hPopupBookmarks
    If Len(BookMark1) Then Menu Add String, hPopupBookmarks, BookMark1,  %IDM_BookMark1,  %MF_Enabled
    If Len(BookMark2) Then Menu Add String, hPopupBookmarks, BookMark2,  %IDM_BookMark2,  %MF_Enabled
    If Len(BookMark3) Then Menu Add String, hPopupBookmarks, BookMark3,  %IDM_BookMark3,  %MF_Enabled
    If Len(BookMark4) Then Menu Add String, hPopupBookmarks, BookMark4,  %IDM_BookMark4,  %MF_Enabled
    If Len(BookMark5) Then Menu Add String, hPopupBookmarks, BookMark5,  %IDM_BookMark5,  %MF_Enabled
End Sub

Sub SelectNextFile(Flag As Long)
   Local iCount,iResult As Long, temp$, hNode As Dword
   ListBox Get Count hDlg, %IDC_ListBox To iCount
   ListBox Get Select hDlg, %IDC_ListBox To iResult
   Select Case Flag
      Case -1
         Select Case iResult
            Case 0         : iResult = 1
            Case 1         : Exit Sub
            Case Else      : Decr iResult
         End Select
      Case 1
         Select Case iResult
            Case 0         : iResult = 1
            Case iCount    : Exit Sub
            Case Else      : Incr iResult
         End Select
   End Select

   ListBox Select hDlg, %IDC_ListBox, iResult
   ListBox Get Text hDlg, %IDC_ListBox, iResult To temp$
   Treeview Get Select hDlg, %IDC_Treeview To hNode
   temp$ = FullTreePath(hNode) + "\" +temp$
   DisplayFileInBrowser temp$
End Sub

Sub AddBookmark
   Local iResult As Long, temp$, newBookMark$, hNode As Dword

   'get new bookmark
   ListBox Get Select hDlg, %IDC_ListBox To iResult
   ListBox Get Text hDlg, %IDC_ListBox, iResult To temp$
   Treeview Get Select hDlg, %IDC_TreeView To hNode
   NewBookMark$ = FullTreePath(hNode) + "\" + temp$

   'no dupes
   If NewBookMark$ = BookMark5 Then Exit Sub
   If NewBookMark$ = BookMark4 Then Exit Sub
   If NewBookMark$ = BookMark3 Then Exit Sub
   If NewBookMark$ = BookMark2 Then Exit Sub
   If NewBookMark$ = BookMark1 Then Exit Sub

   'push new value onto top of list
   BookMark5 = BookMark4
   BookMark4 = BookMark3
   BookMark3 = BookMark2
   BookMark2 = BookMark1
   BookMark1 = newBookMark$

   'remove all menu items
   Menu Delete hPopupBookMarks, ByCmd %IDM_BookMark1
   Menu Delete hPopupBookMarks, ByCmd %IDM_BookMark2
   Menu Delete hPopupBookMarks, ByCmd %IDM_BookMark3
   Menu Delete hPopupBookMarks, ByCmd %IDM_BookMark4
   Menu Delete hPopupBookMarks, ByCmd %IDM_BookMark5

   'add menu items if not empty
   If Len(BookMark1) Then Menu Add String, hPopupBookmarks, BookMark1,  %IDM_BookMark1,  %MF_Enabled
   If Len(BookMark2) Then Menu Add String, hPopupBookmarks, BookMark2,  %IDM_BookMark2,  %MF_Enabled
   If Len(BookMark3) Then Menu Add String, hPopupBookmarks, BookMark3,  %IDM_BookMark3,  %MF_Enabled
   If Len(BookMark4) Then Menu Add String, hPopupBookmarks, BookMark4,  %IDM_BookMark4,  %MF_Enabled
   If Len(BookMark5) Then Menu Add String, hPopupBookmarks, BookMark5,  %IDM_BookMark5,  %MF_Enabled
End Sub

Function ValidExtension(xtn$) As Long
   If Len(xtn$) = 0 Then Exit Function   'not all files have extensions
   If InStr(ImagesList,xtn$) Then Function = 1
End Function

Sub DisplayFileInBrowser(FileName As String)
   Local WB As IWebBrowser2, vVar As Variant, iCount As Long

   'no selection
   If IsFalse(IsFile(FileName)) Then
      WB = OC_GetDispatch(hBrowser)
      WB.Navigate2("about:blank")
      Exit Sub
   End If

   'local file or not
   vVar = "file:///" + FileName
   ListBox Get Count hDlg, %IDC_ListBox To iCount
   Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "File Name:  " + FileName + "   (" + Trim$(Str$(iCount)) + " image files)"

   WB = OC_GetDispatch(hBrowser)
   WB.Navigate2(vVar)
End Sub

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(1)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd  = %IDT_Help           : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_R  : ac(c).cmd  = %IDM_ClearBookmarks : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Function InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
'      If UCase$(szTemp) = "BUTTON" Then @cst.cx = @cst20                           'prompt
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 280                           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.cy = 20                           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 260 : @cst.y = @cst.y - 130  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 375 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function
